gradesML/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('landing_page.urls')),
    path('powxrd/', include('powxrd.urls')),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.SCAN_URL, document_root=settings.SCAN_ROOT)

landing_page/urls.py
from django.urls import path
from . import views

app_name = 'landing_page'

urlpatterns = [
    path('', views.index, name='index'),
]

powxrd/urls.py
from django.urls import path
from . import views
app_name = 'powxrd'

from django.urls import path
from . import views

app_name = 'powxrd'

urlpatterns = [
    path('', views.PowxrdListView.as_view(), name='list'),
    path('engine/', views.EngineView.as_view(), name='engine'),
    path('api/csv/', views.CSVListCreate.as_view(), name='csv_list_create'),
    path('api/scan/', views.ScanListCreate.as_view(), name='scan_list_create'),
    path('api/predictions/', views.PredictionsListCreate.as_view(), name='predictions_list_create'),
    path('engine/', views.EngineAPIView.as_view(), name='engine'),
]

landing_page/models.py
from django.db import models

# Create your models here.

powxrd/models.py
from django.db import models
from django.conf import settings
from django.contrib.postgres.fields import ArrayField

class CSV(models.Model):
    filename = models.FileField(upload_to='scan_upload/', related_name='uploaded_files')
    timestamp = models.DateTimeField(auto_now_add=True)
    activated = models.BooleanField(default=False)

    def __str__(self):
        return f"File id: {self.id}"

class Scan(models.Model):
    angles = ArrayField(models.FloatField())
    intensities = ArrayField(models.FloatField())
    timestamp = models.DateTimeField(auto_now_add=True)
    csv = models.ForeignKey(CSV, on_delete=models.CASCADE)

    def __str__(self):
        return f"Scan is: {self.id}"
    
class Predictions(models.Model):
    labels = ArrayField(models.CharField(max_length=100))
    probabilities = ArrayField(models.FloatField())
    csv = models.ForeignKey(CSV, on_delete=models.CASCADE)

    def __str__(self):
        return f"Predictions is: {self.id}"

powxrd/forms.py
from django.forms import ModelForm
from .models import CSV

class CSVForm(ModelForm):
    class Meta:
        model = CSV
        fields = ['csvfile', 'wavelength']

landing_page/views.py
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, 'index.html')

powxrd/views.py
import os
from django.conf import settings
from django.views.generic.edit import FormView
from .models import CSV, Scan
from .forms import CSVForm

# Create your views here.


from django.views.generic.edit import FormView
from django.urls import reverse_lazy

class ListView(FormView):
    template_name = 'list.html'
    form_class = CSVForm
    success_url = reverse_lazy('powxrd:list')

    def form_valid(self, form):
        request = self.request
        filename_ = request.FILES['csvfile'].name
        path = os.path.join(settings.BASE_DIR, 'scan_upload')
        with open(os.path.join(path, filename_), 'wb+') as destination:
            for chunk in request.FILES['csvfile'].chunks():
                destination.write(chunk)

        form.instance.filename = request.FILES['csvfile']
        form.save()

        request.session['wavelength'] = form.cleaned_data['wavelength']

        return super().form_valid(form)


    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        
        csv_path = ''
        csv_path1 = ''
        documents = CSV.objects.all()
        for document in documents:
            csv_path = document.filename.name
            csv_path1 = '/' + csv_path
            document.delete()

        context['csv_path1'] = csv_path1
        context['documents'] = documents
        return context



from .utils import  process_data
from django.views import View
from django.http import JsonResponse

class EngineView(View):
    def get(self, request, *args, **kwargs):
        spectra_path = os.path.join(str(settings.BASE_DIR), request.session['csv_path'])
        wavelength = request.session['wavelength']
        request.session.pop('csv_path', None)
        request.session.pop('wavelength', None)
        request.session.modified = True
        response_data = process_data(spectra_path, wavelength)

        return JsonResponse(response_data)


from rest_framework import generics
from .models import Scan, CSV
from .serializers import ScanSerializer, ResponseDataSerializer
from rest_framework.response import Response


class ScanListCreateAPIView(generics.ListCreateAPIView):
    serializer_class = ScanSerializer

    def get_queryset(self):
        csv_id = self.kwargs['csv_id']
        return Scan.objects.filter(csv__id=csv_id)

    def perform_create(self, serializer):
        csv_id = self.kwargs['csv_id']
        csv = CSV.objects.get(id=csv_id)
        serializer.save(csv=csv)


class EngineAPIView(generics.GenericAPIView):
    serializer_class = ResponseDataSerializer

    def get(self, request, *args, **kwargs):
        spectra_path = os.path.join(str(settings.BASE_DIR), request.session['csv_path'])
        wavelength = request.session['wavelength']
        response_data = process_data(spectra_path, wavelength)

        serializer = self.get_serializer(data=response_data)
        serializer.is_valid(raise_exception=True)
        return Response(serializer.data)

templates/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
    <head>
        <meta charset="UTF-8">
        <link rel="stylesheet" href=" {% static "mystyle.css" %} ">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@3.3.7/dist/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
        <title></title>
    </head>
    <body background="static/logoS2.png">
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <ul class="nav navbar-nav">
                    <li><a class="navbar-brand" href="{% url 'landing_page:index' %}">Home</a></li>
                    <li><a class="navbar-link" href="{% url 'powxrd:list' %}">Powder XRD</a></li>
                </ul>
            </div>
        </nav>
        <div class="container">
            {% block body_block %}
            
            {% endblock %}
        </div>
    </body>
</html>

templates/base2.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
    <head>
        <meta charset="UTF-8">
        <script src="https://cdn.plot.ly/plotly-2.18.2.min.js"></script>
        <link rel="stylesheet" href=" {% static "mystyle.css" %} ">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@3.3.7/dist/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
        <title></title>
    </head>
    <body>
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <ul class="nav navbar-nav">
                    <li><a class="navbar-brand" href="{% url 'landing_page:index' %}">Home</a></li>
                </ul>
            </div>
        </nav>
        <div class="container">
            {% block body_block %}
            
            {% endblock %}
        </div>
    </body>
</html>

templates/base3.html
<!DOCTYPE html>
{% load static %}
<html lang="en" dir="ltr">
    <head>
        <meta charset="UTF-8">
        <link rel="stylesheet" href=" {% static "mystyle.css" %} ">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@3.3.7/dist/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
        <title></title>
    </head>
    <body>
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <ul class="nav navbar-nav">
                    <li><a class="navbar-brand" href="{% url 'landing_page:index' %}">Home</a></li>
                    <li><a class="navbar-link" href="{% url 'powxrd:list' %}">Powder XRD</a></li>
                </ul>
            </div>
        </nav>
        <div class="container">
            {% block content %}
            
            {% endblock %}
        </div>
    </body>
</html>

templates/index.html
{% extends "base.html" %}

{% block body_block %}

<div class="jumbotron">
    <h2 style="color:black">Determine crystal symmetry from powder XRD diffraction spectra</h2>
    <h3 style="color: black;">Please provide your scan file</h3>
    <h4 style="color: black;">Hit process button afterwards</h4>
</div>

<div class="bottomright">
    <h5 style="color: black;">Equipe Grades Soleil</h5>
</div>

{% endblock %}

templates/landing_page.html
{% extends "base.html" %}

{% block body_block %}

<div class="jumbotron">
    <h2 style="color:black">GRADES ML</h2>
</div>

<div class="bottomright">
    <h5 style="color: black;">Equipe Grades Soleil</h5>
</div>

{% endblock %}

templates/list.html
{% extends "base2.html" %}
{% block body_block %}

<form action="{% url 'powxrd:list' %}" method="POST" enctype="multipart/form-data">
  {% csrf_token %}
  <p>{{ form.non_field_error }}</p>
  <p>{{ form.csvfile.label_tag }} {{ form.csvfile.help_text }}</p>
  <p>{{ form.csvfile.errors }} {{ form.csvfile }}</p>
  <p>
    {{ form.wavelength.label_tag }}
    <input type="number" name="wavelength" step="0.00001" value="1.54184">
  </p>
  <p><input type="submit" name="upload_scan" value="Upload"></p>
</form>

{% if documents %}
<p><input type="submit" value="Click to start Assessment" class="process-button" id="Process"></p>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>

<div class="plots-container">
  <div class="plot" id="plot1"></div>
  <div class="plot" id="plot2"></div>
</div>

<script>
  $(document).ready(function() {
    $("#Process").click(function() {
      $.ajax({
        url: "/powxrd/engine/",
        type: "get",
        dataType: "json",
        success: function(data) {
          // Create the first Plotly graph
          var trace1 = {
            x: data.Q,
            y: data.intensities,
            mode: "lines"
          };

          var data1 = [trace1];

          var layout1 = {
            title: "Original Scan",
            xaxis: { title: "q vector", range: [Math.min(...data.Q), Math.max(...data.Q)] },
            yaxis: { title: "Intensity", range: [0, Math.max(...data.intensities)] },
            height: 400
          };

          Plotly.newPlot('plot1', data1, layout1);

          // Create the second Plotly graph
          var trace2 = {
            x: data.labels,
            y: data.probabilities,
            type: "bar"
          };

          var data2 = [trace2];

          var layout2 = {
            title: "Space Group Predictions",
            xaxis: { title: "Space Group" },
            yaxis: { title: "Probability", range: [0, 1] },
            height: 400
          };

          Plotly.newPlot('plot2', data2, layout2);
        }
      });
    });
  });
</script>

{% endif %}
{% endblock %}

templates/results.html
{% extends 'base3.html' %}

{% block content %}
<h1>Powder XRD classifier for Scan {{ scan.id }} - Below are the top5 space groups with the plot of the scan:</h1>
<p>Timestamp: {{ scan.timestamp }}</p>
<div class="container-fluid">
    <div class="row">
        <div class="col-md-6">       
            <h2>Top5 Classes and Their Probabilities</h2>
            <div>
                {{ graph|safe }}
            </div>
            <div class="col-md-6">
                <h2>Scan plot</h2>
                <div>
                    {{ scan_graph |safe }}
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}